var last_song = '';
var lrc_lines = [];
var current_time;
var last_line = '';
var last_sync_time = 0; 
var lastTitle = '';
//window.retry = false;
widget.onshow = init;
widget.onhide = unactive;

function init()
{
	//window.timer1 = setInterval(updateInfo,2000);
	window.timer2 = setInterval(updatePosition,200);
	window.timer3 = setInterval(syncPosition,1000);
}

function unactive()
{
	try
	{
		clearInterval(window.timer1);
	}catch(e){ }
	try
	{
		clearInterval(window.timer2);
	}catch(e){ }
	try
	{
		clearInterval(window.timer3);
	}catch(e){ }
}

function syncPosition()
{
	if (window.iTunes)
	{
		if (iTunes.update()) //if running
		{
			var pos = iTunes.playerPosition();
			var t = pos*1000;
			current_time = t;
			last_sync_time = t;
			
			if (lastTitle != iTunes.currentTitle())
			{
				lastTitle = iTunes.currentTitle();
				updateInfo();
			}
			
		}
		else
		{
			showNotRunning();
		}
	}
}


function showNotRunning()
{
	$('#info').html('<h1>iTunes is not running</h1>');
	$('#lines').html('');
}

function debug(msg) {
	if (!debug.box) {
		debug.box = document.createElement("div");
		debug.box.setAttribute("style", "background-color: white; " +
										"font-family: monospace; " +
										"border: solid black 3px; " +
										"padding: 10px;");
		document.body.appendChild(debug.box);
		debug.box.innerHTML = "<h1 style='text-align:center'>Debug Output</h1>";
	}
	
	var p = document.createElement("div");
	p.appendChild(document.createTextNode(msg));
	debug.box.appendChild(p);
}

function updatePosition()
{
	current_time+=200;
	ct = current_time + 500;
	var last_time = 0;
	lrcs = $('.lrc');
	for(i=1;i<lrcs.length;i++)
	{
		if (ct > parseInt(lrcs.eq(i-1).attr('id').replace('lrc_',''))
		 && ct < parseInt(lrcs.eq(i).attr('id').replace('lrc_','')))
		{
			var cdom = lrcs.eq(i-1);
			var current = $('.current');
			if (current.data('top') > cdom.data('top') && current.data('top') - cdom.data('top') < cdom.height()+10) return;
			if (last_line != cdom.attr('id') )
			{
				current.removeClass('current');
				cdom.addClass('current');
				last_line = lrcs.eq(i-1).attr('id');
				updateScroll();
				return;
			}
		}
	}
}

function updateScroll()
{
	if ($('.current').length == 0 || $('.current').html().length <= 0) return;
	$('.current').css('opacity',1);
	var prev = $('.current').prev('.lrc');
	var next = $('.current').next('.lrc');
	for(i=0.9;i>=-2;i-=0.3)
	{
		opacity = i;
		if (opacity<=0) opacity = 0;
		if (prev.length > 0)
		{
			prev.css('opacity',opacity-0.3);
			prev = prev.prev('.lrc');
		}
		if (next.length > 0)
		{
			next.css('opacity',opacity);
			next = next.next('.lrc');
		}
	}
	
	var top = $('.current').data('top');
	if (!top || top <= 0 ) return;
	var margintop = 60-parseInt($('.current').data('top'));
	if (margintop >0 ) margintop = 0;
	//$('#lines').animate( { marginTop:margintop },2000);
	$('#lines').css('margin-top',margintop);
}

function updateInfo()
{
	if (window.iTunes)
	{
		if (iTunes.update()) //if running
		{
			widget.system("/usr/bin/osascript info.scpt",function(str)
			{
				updateInfoDo(str.outputString);
			});
		}
	}
}

function updateInfoDo(info)
{
	var song = {};
	if (info)
	{
		info = info.split('|');
		song.artist = info[0];
		song.album = info[1];
		song.name = info[2];
		song.location = info[3];
	}
	else return;
	if (song.name+song.artist == last_song && !window.retry) return;
	last_song = song.name + song.artist;
	$('#info').html('<h1>'+song.artist+' '+song.name+'</h1>');
	$('#lines').remove();
	$('<div id="lines" class="slow"></div>').html('').css('margin-top','-50px').appendTo("#wrapper");

	current_time = 0;
	song.location = '/'+song.location.replace(/^[^\:]+\:/,'').replace(/\:/g,'/').replace(/\s+$/g,'');
	song.lrc = song.location.replace(/\.[a-z0-9]{2,4}$/,'.lrc');
	var para = song.lrc+':'+song.name.replace(':',' ')+':'+song.artist.replace(':',' ');
	if (window.retry) para+=':retry';
	window.retry = false;
	$('<h3 id="loading">正在载入歌词...</h3>').appendTo($('#info'));
	para = encodeURIComponent(para);
	para = para.replace(/\(/g,'%28').replace(/\)/g,'%29').replace(/\,/g,'%2C').replace(/\'/g,'%27').replace(/\-/g,'%forwardslash');
	//$('#info').html('<span style="font-size:10px;">'+para.replace(/\%2F/g,'<br>')+'</span>');
	lrc_lines = [];
	widget.system("/usr/bin/php getlrc.php "+para,function(o)
	{
		loadLrcDo(o.outputString);
	});
	
}

function loadLrcDo(lines)
{
	var dom = ($('#loading').length > 0)?$('#loading'):$('#info');
	if (lines == 'no network')
	{
		dom.html('没有网络连接');
	}
	else if (lines == 'notfound')
	{
		dom.html('没有找到歌词');
	}
	else
	{
		$('#info #loading').html('');
		$('#lines').html(lines);
		var top = 0;
		$('.lrc').each(function()
		{
			$(this).data('top',top);
			top+= $(this).height();
		});
	}
}

function doretry()
{
	if (window.iTunes)
	{
		if (iTunes.update()) //if running
		{
			window.retry = true;
			$('#info').html('<h1>retrying</h1>');
			$('#lines').remove();
			updateInfo();
		}
	}
}